package it.unibas.visualpinco.controllo;

import it.unibas.ping.azioni.AzionePing;
import it.unibas.ping.framework.Applicazione;
import it.unibas.visualpinco.modello.Progetto;
import it.unibas.visualpinco.persistenza.DAOException;
import it.unibas.visualpinco.persistenza.DAOProgetto;
import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

public class AzioneApri implements AzionePing{
    
    public AzioneApri() {
    }
    
    public void esegui(java.util.EventObject evento){
        
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setFileSelectionMode(fileChooser.DIRECTORIES_ONLY);
        if(fileChooser.showOpenDialog(Applicazione.getVistaPrincipale())==fileChooser.APPROVE_OPTION){
            File folder = fileChooser.getSelectedFile();
//            Progetto progetto = new Progetto();
            Progetto progetto = (Progetto)Applicazione.getModello().getBean("progetto");
            progetto.setCartellaProgetto(folder);
            boolean trovatoFileConfigurazione = progetto.inizializza();
            String messaggio = "";
            if(trovatoFileConfigurazione){
                messaggio = "Nella cartella specificata  stato trovato il seguente file di configurazione:\n" + progetto.getFileConfig().getAbsolutePath();
                try{
                    DAOProgetto.caricaProgetto(progetto);
                }catch(DAOException daoe){
                    Applicazione.getVistaPrincipale().finestraErrore("Errore nel caricamento del file di configuarazione.\n" + daoe.toString());
                }
            }else{
                messaggio = "Nella cartella specificata non  stato trovato alcun file di configurazione.";
            }
            Applicazione.getControllo().abilitaAzioneSwing("salvaFileConfigurazione");
            Applicazione.getControllo().abilitaAzioneSwing("salvaFileConfigurazioneConNome");
            Applicazione.getControllo().abilitaAzioneSwing("nuovaAzione");
            Applicazione.getControllo().disabilitaAzioneSwing("modificaAzione");
            Applicazione.getControllo().disabilitaAzioneSwing("nuovoEsito");
            Applicazione.getControllo().disabilitaAzioneSwing("modificaEsito");
            Applicazione.getControllo().abilitaAzioneSwing("creaAzioni");
            Applicazione.getControllo().abilitaAzioneSwing("creaSchermi");
            JOptionPane.showMessageDialog(Applicazione.getVistaPrincipale(),messaggio,"Visual Pinco",JOptionPane.INFORMATION_MESSAGE);
            Applicazione.getModello().putBean("progetto",progetto);
        }
        
    }
    
}
