package it.unibas.visualpinco.controllo;

import it.unibas.ping.azioni.AzionePing;
import it.unibas.ping.framework.Applicazione;
import it.unibas.visualpinco.modello.Azione;
import it.unibas.visualpinco.modello.Progetto;
import it.unibas.visualpinco.persistenza.DAOAzione;
import it.unibas.visualpinco.persistenza.DAOException;
import javax.swing.JOptionPane;


public class AzioneCreaAzioni implements AzionePing{
    
    public AzioneCreaAzioni() {
    }
    public void esegui(java.util.EventObject evento){
        Progetto progetto = (Progetto)Applicazione.getModello().getBean("progetto");
        java.util.List listaAzioni = progetto.getAzioni();
        java.util.List listaAzioniNonImplementate = new java.util.ArrayList();
        for(int i=0;i<listaAzioni.size();i++){
            String sAzione = ((Azione)listaAzioni.get(i)).getNome();
            if(!progetto.esisteAzione(sAzione)){
                listaAzioniNonImplementate.add(sAzione);
            }
        }
        
        if(listaAzioniNonImplementate.size()==0){
            String messaggio = "Non ci sono azioni da implementare!";
            JOptionPane.showMessageDialog(Applicazione.getVistaPrincipale(),messaggio,"VisualPinco",JOptionPane.INFORMATION_MESSAGE);
        }else{
            String messaggio = "Vuoi creare le seguenti azioni (nella cartella /src):\n\n";
            for(int i=0;i<listaAzioniNonImplementate.size();i++){
                String s = (String)listaAzioniNonImplementate.get(i);
                messaggio += s + "\n";
            }
            if(JOptionPane.showConfirmDialog(Applicazione.getVistaPrincipale(),messaggio,"Conferma creazione",JOptionPane.YES_NO_OPTION)==JOptionPane.YES_OPTION){
                for(int i=0;i<listaAzioniNonImplementate.size();i++){
                    String sAzione = (String)listaAzioniNonImplementate.get(i);
                    Azione azione = progetto.getAzione(sAzione);
                    try{
                        DAOAzione.creaAzione(sAzione, progetto.getCartellaSrc(), azione.getNomeClasse(), azione.getNomePackage());
                    }catch(DAOException daoe){
                        String mess = "Impossibile creare il file " + sAzione + "\n" + daoe;
                        Applicazione.getVistaPrincipale().finestraErrore(mess);
                    }
                }
            }
        }
    }
}
