package it.unibas.visualpinco.controllo;

import it.unibas.ping.azioni.AzionePing;
import it.unibas.ping.framework.Applicazione;
import it.unibas.visualpinco.modello.Progetto;
import it.unibas.visualpinco.persistenza.DAOException;
import it.unibas.visualpinco.persistenza.DAOSchermo;
import javax.swing.JOptionPane;

public class AzioneCreaSchermi implements AzionePing{
    
    public AzioneCreaSchermi() {
    }
    public void esegui(java.util.EventObject evento){
        Progetto progetto = (Progetto)Applicazione.getModello().getBean("progetto");
        Object[] listaSchermi = progetto.getListaSchermi();
        java.util.List listaSchermiNonImplementati = new java.util.ArrayList();
        for(int i=0;i<listaSchermi.length;i++){
            String sSchermo = (String)listaSchermi[i];
            if(!progetto.esisteSchermo(sSchermo)){
                listaSchermiNonImplementati.add(sSchermo);
            }
        }
        
        if(listaSchermiNonImplementati.size()==0){
            String messaggio = "Non ci sono schermi da implementare!";
            JOptionPane.showMessageDialog(Applicazione.getVistaPrincipale(),messaggio,"VisualPinco",JOptionPane.INFORMATION_MESSAGE);
        }else{
            String messaggio = "Vuoi creare i seguenti schermi (nella cartella /web):\n\n";
            for(int i=0;i<listaSchermiNonImplementati.size();i++){
                String s = (String)listaSchermiNonImplementati.get(i);
                messaggio += s + "\n";
            }
            if(JOptionPane.showConfirmDialog(Applicazione.getVistaPrincipale(),messaggio,"Conferma creazione",JOptionPane.YES_NO_OPTION)==JOptionPane.YES_OPTION){
                for(int i=0;i<listaSchermiNonImplementati.size();i++){
                    String sSchermo = (String)listaSchermiNonImplementati.get(i);
                    try{
                        DAOSchermo.creaSchermo(sSchermo, progetto.getCartellaWeb());
                    }catch(DAOException daoe){
                        String mess = "Impossibile creare il file " + sSchermo + "\n" + daoe;
                        Applicazione.getVistaPrincipale().finestraErrore(mess);
                    }
                }
            }
        }
    }
}
