package it.unibas.visualpinco.controllo;

import it.unibas.ping.azioni.AzionePing;
import it.unibas.ping.framework.Applicazione;
import it.unibas.visualpinco.modello.Progetto;
import it.unibas.visualpinco.persistenza.DAOException;
import it.unibas.visualpinco.persistenza.DAOProgetto;
import javax.swing.JOptionPane;

public class AzioneSalva implements AzionePing{
    
    public AzioneSalva() {
    }
    
    public void esegui(java.util.EventObject evento){
        Progetto progetto = (Progetto)Applicazione.getModello().getBean("progetto");
        
       String messaggioErrore = progetto.controllaProgetto();

       if(!messaggioErrore.equals("")){
           Applicazione.getVistaPrincipale().finestraErrore(messaggioErrore);
       }else{
           String messaggio = "Sei sicuro di voler salvare le modifiche apportate al file " + progetto.getFileConfig().getAbsolutePath()  +"?";
           if(JOptionPane.showConfirmDialog(Applicazione.getVistaPrincipale(),messaggio,"Conferma salvataggio",JOptionPane.YES_NO_OPTION)==JOptionPane.YES_OPTION){
               try{
                   DAOProgetto.salvaProgetto(progetto,null);
               }catch(DAOException daoe){
                   messaggioErrore = "Impossibile salvare il file!\n" + daoe.toString();
                   Applicazione.getVistaPrincipale().finestraErrore(messaggioErrore);
               }
           }
       }
        
    }
}
