package it.unibas.visualpinco.controllo;

import it.unibas.ping.azioni.AzionePing;
import it.unibas.ping.framework.Applicazione;
import it.unibas.visualpinco.modello.Azione;
import it.unibas.visualpinco.modello.Comando;
import it.unibas.visualpinco.modello.Progetto;

public class AzioneSalvaAzione implements AzionePing{
    
    public AzioneSalvaAzione() {
    }
    public void esegui(java.util.EventObject evento){
        Progetto progetto = (Progetto)Applicazione.getModello().getBean("progetto");
        String nomeAzione = (String)(Applicazione.getVistaPrincipale().trovaValore("txtAzione"));
        String nomeComando = (String)(Applicazione.getVistaPrincipale().trovaValore("txtComando"));
        Azione azione = (Azione)Applicazione.getModello().getBean("azioneModificare");
        Comando comando = azione.getComando();
        boolean azioneNuova = ((Boolean)Applicazione.getModello().getBean("azioneNuova")).booleanValue();
        
        String errori = "";
        if(nomeAzione==null||nomeAzione.equals("")){
            errori += "Devi specificare il nome dell'azione\n";
        }
        if(nomeComando==null||nomeComando.equals("")){
            errori += "Devi specificare il nome del comando\n";
        }
        if(azioneNuova && progetto.getAzione(nomeAzione)!=null){
            errori += "L'azione specificata esiste gi\n";
        }
        if(!azioneNuova && !(nomeAzione.equals(azione.getNome())) && progetto.getAzione(nomeAzione)!=null){
            errori += "L'azione specificata esiste gi\n";
        }
        if(azioneNuova && progetto.esisteComando(nomeComando)){
            errori += "Il comando specificato esiste gi\n";
        }
        if(!azioneNuova && !(nomeComando.equals(comando.getNome())) && progetto.esisteComando(nomeComando)){
            errori += "Il comando specificato esiste gi\n";
        }
        if(!nomeComando.endsWith(".cmd")){
            errori += "Il comando deve terminare con .cmd\n";
        }
        
        if(errori.equals("")){
            //SALVA
            if(azioneNuova){
                azione = new Azione();
                comando = new Comando();
                azione.setNome(nomeAzione);
                comando.setNome(nomeComando);
                azione.setComando(comando);
                azione.setProgetto(progetto);
                progetto.addAzione(azione);
            }else{
                azione.setNome(nomeAzione);
                comando.setNome(nomeComando);
            }
            Applicazione.getVistaPrincipale().eseguiSchermo("chiudiFinestraAzione");
        }else{
            Applicazione.getVistaPrincipale().finestraErrore(errori);
        }
    }
}
