package it.unibas.visualpinco.modello;

import it.unibas.ping.eventi.EventoModificaCollezione;
import it.unibas.ping.eventi.Osservabile;
import it.unibas.ping.framework.Applicazione;
import java.util.List;

public class Azione extends Osservabile {
    
    private String nome = "";
    private Comando comando;
    private List esiti = new java.util.ArrayList();
    private Progetto progetto;
    private String nomeClasse = "";
    private String nomePackage = "";
    
    public Azione() {
    }

    public String getNome() {
        return nome;
    }

    public void setNome(String nome) {
        int i = nome.lastIndexOf(".");
        if(i==-1){
            this.setNomeClasse(nome);
            this.setNomePackage("");
        }else{
            this.setNomeClasse(nome.substring(i + 1));
            this.setNomePackage(nome.substring(0,i));
        }
        this.nome = nome;
    }

    public Comando getComando() {
        return comando;
    }

    public void setComando(Comando comando) {
        this.comando = comando;
    }

    public List getEsiti() {
        return esiti;
    }

    public void setEsiti(List esiti) {
        this.esiti = esiti;
    }
    
    public int getSizeEsiti(){
        return this.esiti.size();
    }
    
    public void addEsito(Esito esito){
        this.esiti.add(esito);
        progetto.notificaModificaCollezione(new EventoModificaCollezione(progetto, "azioni",0, EventoModificaCollezione.AGGIUNTA));
    }

    public Esito getEsito(String nome){
        for(int i=0;i<esiti.size();i++){
            Esito esito = (Esito)esiti.get(i);
            if(esito.getNome().equals(nome)){
                return esito;
            }
        }
        return null;
    }
    
    public boolean esisteSchermo(String nome){
        for(int i=0;i<esiti.size();i++){
            Esito esito = (Esito)esiti.get(i);
            if(esito.getSchermo().getNome().equals(nome)){
                return true;
            }
        }
        return false;
    }
    
    public void removeEsito(String nome){
        for(int i=0;i<esiti.size();i++){
            Esito e = (Esito)esiti.get(i);
            if(e.getNome().equals(nome)){
                this.esiti.remove(i); 
                progetto.notificaModificaCollezione(new EventoModificaCollezione(progetto, "azioni",0, EventoModificaCollezione.ELIMINA));
                return;
            }
        }
    }
    
    public String toString(){
        String s = "";
        if(comando==null){
            s += "Azione: " + nome + "\n";
        }else{
            s += "Azione: " + nome + " - Comando: " + comando.toString() + "\n";
        }
        for(int i=0;i<esiti.size();i++){
            Esito esito = (Esito)esiti.get(i);
            s += "\t" + esito.toString();
        }
        return s;
    }

    public Progetto getProgetto() {
        return progetto;
    }

    public void setProgetto(Progetto progetto) {
        this.progetto = progetto;
    }

    public String getNomeClasse() {
        return nomeClasse;
    }

    public void setNomeClasse(String nomeClasse) {
        this.nomeClasse = nomeClasse;
    }

    public String getNomePackage() {
        return nomePackage;
    }

    public void setNomePackage(String nomePackage) {
        this.nomePackage = nomePackage;
    }
}
