package it.unibas.visualpinco.persistenza;

import it.unibas.ping.framework.Applicazione;
import java.io.File;
import java.io.IOException;

public class DAOAzione {
    
    public DAOAzione() {
    }
    
    public static void creaAzione(String sAzione, File cartellaSrc, String nomeClasse, String nomePackage) throws DAOException{
        sAzione = sAzione.replace('.', java.io.File.separatorChar);
        sAzione += ".java";
        String fileToMake = cartellaSrc.getAbsolutePath() + java.io.File.separatorChar + sAzione;
        Applicazione.logFine("File da creare: " + fileToMake);
        java.io.PrintWriter file = null;
        try{
            File f = new File(fileToMake);
            if(f.exists()){
                throw new DAOException("Il file gi esiste");
            }
            file = new java.io.PrintWriter(new java.io.FileWriter(fileToMake));
            // CREAZIONE DEL FILE - DOVREBBE BASARSI SU TEMPLATE - DA IMPLEMENTARE
            file.write("//Azione creata con VisualPinco\n");
            file.write("package " + nomePackage + ";\n\n");
            file.write("import it.unibas.pinco.azioni.Azione;\n");
            file.write("import javax.servlet.http.HttpServletRequest;\n");
            file.write("import javax.servlet.http.HttpSession;\n\n");
            file.write("public class " + nomeClasse + " implements Azione{\n\n");
            file.write("    public " + nomeClasse + "() {\n");
            file.write("    }\n\n");
            file.write("    public String esegui(HttpServletRequest request){\n\n");
            file.write("    }\n\n");
            file.write("}");
            
            file.close();
        }catch(IOException ioe){
            throw new DAOException("Errore nella creazione del file. " + ioe.toString());
        }finally{
            if(file!=null){
                file.close();
            }
        }
    }
    
}
