package it.unibas.visualpinco.persistenza;

import it.unibas.ping.framework.Applicazione;
import java.io.File;
import java.io.IOException;

public class DAOSchermo {
    
    public DAOSchermo() {
    }
    public static void creaSchermo(String sSchermo, File cartellaWeb) throws DAOException{
        String fileToMake = cartellaWeb.getAbsolutePath() + java.io.File.separatorChar + sSchermo;
        Applicazione.logFine("File da creare: " + fileToMake);
        java.io.PrintWriter file = null;
        try{
            File f = new File(fileToMake);
            if(f.exists()){
                throw new DAOException("Il file gi esiste");
            }
            file = new java.io.PrintWriter(new java.io.FileWriter(fileToMake));
            file.write("<?xml version=\"1.0\" encoding=\"iso-8859-1\" ?>\n\n");
            file.write("<%@ taglib uri=\"http://www.db.unibas.it/users/mecca/diogene/pinco\" prefix=\"pinco\" %>\n");
            file.write("<%@ taglib uri=\"http://java.sun.com/jsp/jstl/core\" prefix=\"c\" %>\n\n");
            file.write("<pinco:noCache />\n\n");
            file.write("<jsp:include page=\"intestazione.jsp\" />\n\n");
            file.write("<body>\n\n");
            file.write("    <h2>Applicazione web con pinco.</h2>\n");
            file.write("    <h1>Pagina di destinazione.</h1>\n");
            file.write("    <p><a href=\"index.jsp\">Punto di inizio dell'applicazione</a></p>\n");
            file.write("    <pinco:logoPinco />\n\n");
            file.write("</body>\n");
            file.write("</html>");
            
            file.close();
        }catch(IOException ioe){
            throw new DAOException("Errore nella creazione del file. " + ioe.toString());
        }finally{
            if(file!=null){
                file.close();
            }
        }
    }
}
