package it.unibas.visualpinco.vista;

import it.unibas.ping.componenti.PTextField;
import it.unibas.ping.framework.VistaFinestraSecondaria;
import it.unibas.visualpinco.utilita.SwingManager;
import java.awt.Font;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class FinestraInserisciAzione extends VistaFinestraSecondaria{
    
    private PTextField txtAzione = new PTextField("azioneModificare","nome");
    private PTextField txtComando = new PTextField("comandoModificare","nome");
    
    public FinestraInserisciAzione() {
    }
    
    public void inizializza(){
        this.setTitle("Inserisci azione");
        this.getContentPane().setLayout(new BoxLayout(this.getContentPane(), BoxLayout.Y_AXIS));
        txtAzione.setName("txtAzione");
        txtComando.setName("txtComando");
        txtAzione.setAction(this.getControllo().getAzioneSwing("salvaAzione"));
        txtComando.setAction(this.getControllo().getAzioneSwing("salvaAzione"));
        txtAzione.setColumns(30);
        txtComando.setColumns(28);
        this.getContentPane().add(creaPannelloTitolo());
        this.getContentPane().add(creaPannelloCentrale());
        this.getContentPane().add(creaPannelloPulsanti());
    }
    
    private JPanel creaPannelloTitolo(){
        JLabel lTitle = new JLabel("Nuova Azione");
        Font font = new Font("Tahoma", Font.BOLD,14);
        lTitle.setFont(font);
        JPanel pTitle = new JPanel();
        pTitle.add(lTitle);
        return pTitle;
    }
    
    private JPanel creaPannelloCentrale(){
        JPanel pannelloAzione = new JPanel();
        JPanel pannelloComando = new JPanel();
        
        pannelloAzione.add(new JLabel("Azione:"));
        pannelloAzione.add(txtAzione);
        pannelloComando.add(new JLabel("Comando:"));
        pannelloComando.add(txtComando);
        JPanel pannelloCentrale = new JPanel();
        pannelloCentrale.setLayout(new BoxLayout(pannelloCentrale, BoxLayout.Y_AXIS));
        pannelloCentrale.add(pannelloAzione);
        pannelloCentrale.add(pannelloComando);
        return pannelloCentrale;
    }
    
    private JPanel creaPannelloPulsanti(){
        JPanel pannelloPulsanti = new JPanel();
        
        pannelloPulsanti.add(new JButton(this.getControllo().getAzioneSwing("salvaAzione")));
        pannelloPulsanti.add(new JButton(this.getControllo().getAzioneSwing("annullaAzione")));
        
        return pannelloPulsanti;
    } 
    
    public void schermoNuovaAzione(){
        this.setModal(true);
        this.pack();
        SwingManager.centra(this);
        this.setVisible(true);
    }
    public void chiudiFinestraAzione(){
        this.setVisible(false);
    }
}
