package it.unibas.visualpinco.vista;

import it.unibas.ping.componenti.PLabel;
import it.unibas.ping.componenti.PTextField;
import it.unibas.ping.framework.VistaFinestraSecondaria;
import it.unibas.visualpinco.utilita.SwingManager;
import java.awt.Font;
import javax.swing.*;

public class FinestraInserisciEsito extends VistaFinestraSecondaria{
    
    private PTextField txtEsito = new PTextField("esitoModificare","nome");
    private PTextField txtSchermo = new PTextField("schermoModificare","nome");
    
    public FinestraInserisciEsito() {
    }
    
    public void inizializza(){
        this.setTitle("Inserisci esito");
        this.getContentPane().setLayout(new BoxLayout(this.getContentPane(), BoxLayout.Y_AXIS));
        txtEsito.setName("txtEsito");
        txtSchermo.setName("txtSchermo");
        txtEsito.setAction(this.getControllo().getAzioneSwing("salvaEsito"));
        txtSchermo.setAction(this.getControllo().getAzioneSwing("salvaEsito"));
        txtEsito.setColumns(30);
        txtSchermo.setColumns(28);
        this.getContentPane().add(creaPannelloTitolo());
        this.getContentPane().add(creaPannelloCentrale());
        this.getContentPane().add(creaPannelloPulsanti());
    }
    
    private JPanel creaPannelloTitolo(){
        JLabel lTitle = new JLabel("Nuovo Esito");
        Font font = new Font("Tahoma", Font.BOLD,14);
        lTitle.setFont(font);
        JPanel pTitle = new JPanel();
        JPanel lTitleUp = new JPanel();
        JPanel lTitleDown = new JPanel();
        lTitleUp.add(lTitle);
        lTitleDown.add(new PLabel("azioneModificare","nome"));
        pTitle.setLayout(new BoxLayout(pTitle, BoxLayout.Y_AXIS));
        pTitle.add(lTitleUp);
        pTitle.add(lTitleDown);
        return pTitle;
    }
    
    private JPanel creaPannelloCentrale(){
        JPanel pannelloAzione = new JPanel();
        JPanel pannelloComando = new JPanel();
        
        pannelloAzione.add(new JLabel("Esito:"));
        pannelloAzione.add(txtEsito);
        pannelloComando.add(new JLabel("Schermo:"));
        pannelloComando.add(txtSchermo);
        JPanel pannelloCentrale = new JPanel();
        pannelloCentrale.setLayout(new BoxLayout(pannelloCentrale, BoxLayout.Y_AXIS));
        pannelloCentrale.add(pannelloAzione);
        pannelloCentrale.add(pannelloComando);
        return pannelloCentrale;
    }
    
    private JPanel creaPannelloPulsanti(){
        JPanel pannelloPulsanti = new JPanel();
        
        pannelloPulsanti.add(new JButton(this.getControllo().getAzioneSwing("salvaEsito")));
        pannelloPulsanti.add(new JButton(this.getControllo().getAzioneSwing("annullaEsito")));
        
        return pannelloPulsanti;
    } 
    
    public void schermoNuovoEsito(){
        this.setModal(true);
        this.pack();
        SwingManager.centra(this);
        this.setVisible(true);
    }
    public void chiudiFinestraEsito(){
        this.setVisible(false);
    }
}