package it.unibas.visualpinco.vista;
import com.jgoodies.looks.plastic.PlasticLookAndFeel;
import com.jgoodies.looks.plastic.PlasticXPLookAndFeel;
import com.jgoodies.looks.plastic.theme.Silver;
import it.unibas.ping.componenti.PLabel;
import it.unibas.ping.framework.Applicazione;
import it.unibas.ping.framework.VistaFramePrincipale;
import it.unibas.visualpinco.modello.Progetto;
import it.unibas.visualpinco.utilita.SwingManager;
import java.awt.BorderLayout;
import java.awt.Font;
import javax.swing.*;

public class Vista extends VistaFramePrincipale{
    
    static{
       PlasticLookAndFeel.setMyCurrentTheme(new Silver());
       try {
          UIManager.setLookAndFeel(new PlasticXPLookAndFeel());
       } catch (Exception e) {}
        JFrame.setDefaultLookAndFeelDecorated(true);
        JDialog.setDefaultLookAndFeelDecorated(true);
    }
    
    public Vista() {
        
    }
    
    public void inizializza(){
        inizializzaSchermi();
        this.setTitle("Visual Pinco");
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);
        
        this.setJMenuBar(creaMenu());
        
        this.getContentPane().add(createPannelloSuperiore(),BorderLayout.NORTH);
                
        Progetto progetto = (Progetto)this.getModello().getBean("progetto");
        JTable jTable = new JTable(new ModelloTabella(progetto));
        jTable.setName("tabellaProgetto");
        jTable.getSelectionModel().addListSelectionListener(this.controllo.getListSelectionListener("cambiaSelezione"));
        jTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        JScrollPane scrollPane = new JScrollPane();
        scrollPane.setViewportView(jTable);
        this.getContentPane().add(scrollPane,BorderLayout.CENTER);
        
        this.getContentPane().add(createPannelloPulsanti(),BorderLayout.SOUTH);

        this.pack();
        SwingManager.centra(this);
        this.setVisible(true);
    }
    
    private void inizializzaSchermi(){
        this.getSottoVista("finestraAzione").inizializza();
        this.getSottoVista("finestraEsito").inizializza();
    }
    
    public void finestraErrore(java.lang.String messaggio) {
        JOptionPane.showMessageDialog(Applicazione.getVistaPrincipale(),messaggio,"Errore",JOptionPane.ERROR_MESSAGE);
    }
    
    private JPanel createPannelloPulsanti(){
        JPanel pannelloPulsanti = new JPanel();
        JPanel pannelloPulsantiUp = new JPanel();
        JPanel pannelloPulsantiMiddle = new JPanel();
        JPanel pannelloPulsantiDown = new JPanel();
        pannelloPulsantiUp.add(new JButton(this.getControllo().getAzioneSwing("apriCartellaProgetto")));
        pannelloPulsantiUp.add(new JButton(this.getControllo().getAzioneSwing("salvaFileConfigurazione")));
        pannelloPulsantiUp.add(new JButton(this.getControllo().getAzioneSwing("salvaFileConfigurazioneConNome")));
   
        pannelloPulsantiMiddle.add(new JButton(this.getControllo().getAzioneSwing("nuovaAzione")));
        pannelloPulsantiMiddle.add(new JButton(this.getControllo().getAzioneSwing("modificaAzione")));
        pannelloPulsantiMiddle.add(new JButton(this.getControllo().getAzioneSwing("eliminaAzione")));
        
        pannelloPulsantiMiddle.add(new JButton(this.getControllo().getAzioneSwing("nuovoEsito")));
        pannelloPulsantiMiddle.add(new JButton(this.getControllo().getAzioneSwing("modificaEsito")));
        pannelloPulsantiMiddle.add(new JButton(this.getControllo().getAzioneSwing("eliminaEsito")));
        
        pannelloPulsantiDown.add(new JButton(this.getControllo().getAzioneSwing("creaAzioni")));
        pannelloPulsantiDown.add(new JButton(this.getControllo().getAzioneSwing("creaSchermi")));
        
        pannelloPulsanti.setLayout(new BoxLayout(pannelloPulsanti, BoxLayout.Y_AXIS));
        pannelloPulsanti.add(pannelloPulsantiUp);
        pannelloPulsanti.add(pannelloPulsantiMiddle);
        pannelloPulsanti.add(pannelloPulsantiDown);
        return pannelloPulsanti;
    }
    
    private JPanel createPannelloSuperiore(){
        JLabel lTitle = new JLabel("Visual Pinco");
        Font font = new Font("Tahoma", Font.BOLD,18);
        lTitle.setFont(font);
        JPanel pTitle = new JPanel();
        pTitle.add(lTitle);
        JPanel pNome = new JPanel();
        pNome.add(new PLabel("progetto","nomeProgetto"));   
        JPanel panelScritta = new JPanel();
        panelScritta.add(pTitle);
        panelScritta.add(pNome);
        panelScritta.setLayout(new BoxLayout(panelScritta, BoxLayout.Y_AXIS));
        
        JPanel pannelloTitolo = new JPanel();
        pannelloTitolo.setLayout(new BoxLayout(pannelloTitolo, BoxLayout.Y_AXIS));
        pannelloTitolo.add(panelScritta);
        return pannelloTitolo;
    }
    
    
    public JMenuBar creaMenu(){
        JMenuBar jMenuBar = new JMenuBar();
        JMenu mnuFile = new JMenu("File");
           mnuFile.add(new JMenuItem(this.getControllo().getAzioneSwing("apriCartellaProgetto")));
           mnuFile.add(new JMenuItem(this.getControllo().getAzioneSwing("salvaFileConfigurazione")));
           mnuFile.add(new JMenuItem(this.getControllo().getAzioneSwing("salvaFileConfigurazioneConNome")));
           mnuFile.addSeparator();
           mnuFile.add(new JMenuItem(this.getControllo().getAzioneSwing("nuovaAzione")));
           mnuFile.add(new JMenuItem(this.getControllo().getAzioneSwing("modificaAzione")));
           mnuFile.add(new JMenuItem(this.getControllo().getAzioneSwing("eliminaAzione")));
           mnuFile.add(new JMenuItem(this.getControllo().getAzioneSwing("nuovoEsito")));
           mnuFile.add(new JMenuItem(this.getControllo().getAzioneSwing("modificaEsito")));
           mnuFile.add(new JMenuItem(this.getControllo().getAzioneSwing("eliminaEsito")));
           mnuFile.addSeparator();
           mnuFile.add(new JMenuItem(this.getControllo().getAzioneSwing("creaAzioni")));
           mnuFile.add(new JMenuItem(this.getControllo().getAzioneSwing("creaSchermi")));
           mnuFile.addSeparator();
           mnuFile.add(new JMenuItem(this.getControllo().getAzioneSwing("esci")));
        JMenu mnuAbout = new JMenu("?");
           mnuAbout.add(new JMenuItem(this.getControllo().getAzioneSwing("about")));
           mnuAbout.add(new JMenuItem(this.getControllo().getAzioneSwing("aboutPing")));
           
        jMenuBar.add(mnuFile);
        jMenuBar.add(mnuAbout);
        return jMenuBar;
    }
}
