package it.unibas.visualpinco.test.persistenza;

import it.unibas.ping.framework.Applicazione;
import it.unibas.visualpinco.modello.Progetto;
import it.unibas.visualpinco.persistenza.DAOException;
import it.unibas.visualpinco.persistenza.DAOProgetto;
import junit.framework.*;

public class TestDAOProgetto extends TestCase {
    
    public TestDAOProgetto(String testName) {
        super(testName);
    }

    protected void setUp() throws Exception {
    }

    protected void tearDown() throws Exception {
    }

    public void testCarica(){
        Progetto p = new Progetto();
        p.setCartellaProgetto("C:\\prova");
        if(!p.inizializza()){
            Assert.fail("Impossibile trovare il file pinco-config.xml nella cartella di progetto specificata");
            return;
        }
        try{
            DAOProgetto.caricaProgetto(p);
            Assert.assertTrue("Esiste AzioneLogin", p.esisteAzione("it.unibas.bollettini.controllo.AzioneInizia"));
            Assert.assertTrue("Esiste AzioneListaDvd", p.esisteAzione("it.unibas.bollettini.controllo.AzioneMenu"));
            Assert.assertTrue("Non Esiste AzioneInesistente", !p.esisteAzione("it.unibas.controllo.ciao.AzioneInesistente"));
            Assert.assertTrue("Non Esiste AzioneInzi", !p.esisteAzione("it.unibas.bollettini.controllo.AzioneInizi"));
            
            Assert.assertTrue("Esiste /errore.jsp", p.esisteSchermo("/errore.jsp"));
            Assert.assertTrue("Esiste /cartella/paga.jsp", p.esisteSchermo("/cartella/paga.jsp"));
            Assert.assertTrue("Non Esiste /cartella/paaga.jsp", !p.esisteSchermo("/cartella/paaga.jsp"));
            Assert.assertTrue("Non Esiste /s.jsp", !p.esisteSchermo("/s.jsp"));
            
            String prima = p.toString();
            
            DAOProgetto.salvaProgetto(p,null);

            p = new Progetto();
            p.setCartellaProgetto("C:\\prova");
            p.inizializza();
            
            DAOProgetto.caricaProgetto(p);
            
            String dopo = p.toString();
            
            Applicazione.logFine(prima);
            Applicazione.logFine(dopo);
            
            Assert.assertTrue("I due file sono uguali",prima.equals(dopo));
        }catch(DAOException daoe){
            Assert.fail("Eccezione " + daoe.toString());
        }
    }
}
